//Number of keys
#define KEY_NUMBER		29u


#define KEY_NONE		0x00

//Key modifiers bits
#define LEFT_CTRL  		0x01
#define LEFT_SHIFT 		0x02
#define LEFT_ALT   		0x04
#define LEFT_WIN 		0x08
#define RIGHT_CTRL  	0x10
#define RIGHT_SHIFT 	0x20
#define RIGHT_ALT   	0x40
#define RIGHT_WIN	 	0x80

//Key codes
#define KEY_A			0x04
#define KEY_B			0x05
#define KEY_C			0x06
#define KEY_D			0x07
#define KEY_E			0x08
#define KEY_F			0x09
#define KEY_G			0x0A
#define KEY_H			0x0B
#define KEY_I			0x0C
#define KEY_J			0x0D
#define KEY_K			0x0E
#define KEY_L			0x0F
#define KEY_M			0x10
#define KEY_N			0x11
#define KEY_O			0x12
#define KEY_P			0x13
#define KEY_Q			0x14
#define KEY_R			0x15
#define KEY_S			0x16
#define KEY_T			0x17
#define KEY_U			0x18
#define KEY_V			0x19
#define KEY_W			0x1A
#define KEY_X			0x1B
#define KEY_Y			0x1C
#define KEY_Z			0x1D

#define KEY_1			0x1E
#define KEY_2			0x1F
#define KEY_3			0x20
#define KEY_4			0x21
#define KEY_5			0x22
#define KEY_6			0x23
#define KEY_7			0x24
#define KEY_8			0x25
#define KEY_9			0x26
#define KEY_0			0x27

#define KEY_ENTER		0x28
#define KEY_ESC			0x29
#define KEY_BACKSPACE	0x2A
#define KEY_TAB			0x2B
#define KEY_SPACE		0x2C
#define KEY_MINUS		0x2D
#define KEY_EQUAL		0x2E
#define KEY_LEFTBRACE	0x2F /* [ or { */
#define KEY_RIGHTBRACE	0x30 /* ] or } */
#define KEY_BACKSLASH	0x31 /* \ or | */
#define KEY_HASHTILDE	0x32 /* \ or | */
#define KEY_SEMICOLON	0x33 /* ; or : */
#define KEY_APOSTROPHE	0x34 /* ' or " or э */
#define KEY_GRAVE		0x35 /* ` or ~ or ё */
#define KEY_COMMA		0x36 /* , or < or б */
#define KEY_DOT			0x37 /* . or > or ю */
#define KEY_SLASH		0x38 /* / or ? */
#define KEY_CAPSLOCK	0x39

#define KEY_F1			0x3A
#define KEY_F2			0x3B
#define KEY_F3			0x3C
#define KEY_F4			0x3D
#define KEY_F5			0x3E
#define KEY_F6			0x3F
#define KEY_F7			0x40
#define KEY_F8			0x41
#define KEY_F9			0x42
#define KEY_F10			0x43
#define KEY_F11			0x44
#define KEY_F12			0x45

#define KEY_PRINTSCREEN	0x46
#define KEY_SCROLLLOCK	0x47
#define KEY_PAUSEBREAK	0x48
#define KEY_INSERT		0x49
#define KEY_HOME		0x4A
#define KEY_PAGEUP		0x4B
#define KEY_DELETE		0x4C
#define KEY_END			0x4D
#define KEY_PAGEDOWN	0x4E
#define KEY_RIGHT		0x4F
#define KEY_LEFT		0x50
#define KEY_DOWN		0x51
#define KEY_UP			0x52

#define KEY_NUMLOCK		0x53

//NP = Numpad
#define KEY_NP_SLASH	0x54
#define KEY_NP_ASTERISK	0x55
#define KEY_NP_MINUS	0x56
#define KEY_NP_PLUS		0x57
#define KEY_NP_ENTER	0x58
#define KEY_NP_1		0x59
#define KEY_NP_2		0x5A
#define KEY_NP_3		0x5B
#define KEY_NP_4		0x5C
#define KEY_NP_5		0x5D
#define KEY_NP_6		0x5E
#define KEY_NP_7		0x5F
#define KEY_NP_8		0x60
#define KEY_NP_9		0x61
#define KEY_NP_0		0x62
#define KEY_NP_DOT		0x63


//Media keys
#define KEY_SCAN_NEXT 	0xE0
#define KEY_SCAN_PREV 	0xE1
#define KEY_STOP      	0xE2
#define KEY_PAUSE     	0xE3
#define KEY_MUTE      	0xE4
#define KEY_VOL_UP    	0xE5
#define KEY_VOL_DOWN   	0xE6

//================================================
//===============================================
//Other non supporting codes:
//#define KEY_OPEN		0x74
//#define KEY_HELP		0x75
//#define KEY_PROPS		0x76
//#define KEY_FRONT		0x77
//#define KEY_STOP		0x78
//#define KEY_AGAIN		0x79
//#define KEY_UNDO		0x7A
//#define KEY_CUT			0x7B
//#define KEY_COPY		0x7C
//#define KEY_PASTE		0x7D
//#define KEY_FIND		0x7E
//#define KEY_MUTE		0x7F
//#define KEY_VOLUMEUP	0x80
//#define KEY_VOLUMEDOWN	0x81
//#define KEY_MEDIA_PLAY			0xE8
//#define KEY_MEDIA_STOPCD		0xE9
//#define KEY_MEDIA_PREVIOUS		0xEA
//#define KEY_MEDIA_NEXTSONG		0xEB
//#define KEY_MEDIA_EJECTCD		0xEC
//#define KEY_MEDIA_VOLUMEUP		0xED
//#define KEY_MEDIA_VOLUMEDOWN	0xEE
//#define KEY_MEDIA_MUTE			0xEF
//#define KEY_MEDIA_WWW			0xF0
//#define KEY_MEDIA_BACK 			0xF1
//#define KEY_MEDIA_FORWARD		0xF2
//#define KEY_MEDIA_STOP			0xF3
//#define KEY_MEDIA_FIND			0xF4
//#define KEY_MEDIA_SCROLLUP		0xF5
//#define KEY_MEDIA_SCROLLDOWN	0xF6
//#define KEY_MEDIA_EDIT			0xF7
//#define KEY_MEDIA_SLEEP			0xF8
//#define KEY_MEDIA_COFFEE		0xF9
//#define KEY_MEDIA_REFRESH		0xFA
//#define KEY_MEDIA_CALC			0xFB
//
//#define KEY_NONE		0x00
//#define KEY_ERR_OVF		0x01
//#define KEY_ERR_POST	0x02
//#define KEY_UNDEFINED1	0x03
//
//#define KEY_102			0x64 /* Non-US \ and | */
//#define KEY_APP_MENU	0x65 /* Application menu*/
//#define KEY_POWER		0x66
//#define KEY_NP_EQUAL	0x67
//#define KEY_F13			0x68
//#define KEY_F14			0x69
//#define KEY_F15			0x6A
//#define KEY_F16			0x6B
//#define KEY_F17			0x6C
//#define KEY_F18			0x6D
//#define KEY_F19			0x6E
//#define KEY_F20			0x6F
//#define KEY_F21			0x70
//#define KEY_F22			0x71
//#define KEY_F23			0x72
//#define KEY_F24			0x73

//#define KEY_NP_LEFTPAREN 0xB6
//#define KEY_NP_RIGHTPAREN 0xB7
//#define KEY_NP_COMMA	0x85


//#define KEY_RO			0x87
//#define KEY_KATAKANAHIRAGANA	0x88
//#define KEY_YEN			0x89
//#define KEY_HENKAN		0x8A
//#define KEY_MUHENKAN	0x8B
//#define KEY_KPJPCOMMA	0x8C
//
//#define KEY_HANGEUL		0x90 /* LANG1 */
//#define KEY_HANJA		0x91 /* LANG2 */
//#define KEY_KATAKANA	0x92 /* LANG3 */
//#define KEY_HIRAGANA	0x93 /* LANG4 */
//#define KEY_ZENKAKUHANKAKU	0x94 /* LANG5 */


//0x82 Locking Caps Lock
//0x83 Locking Num Lock
//0x84 Locking Scroll Lock
//0x86 Numpad Equal Sign
//0x8D International7
//0x8E International8
//0x8F International9

//0xB8 Numpad {
//0xB9 Numpad }
//0xBA Numpad Tab
//0xBB Numpad Backspace
//0xBC Numpad A
//0xBD Numpad B
//0xBE Numpad C
//0xBF Numpad D
//0xC0 Numpad E
//0xC1 Numpad F
//0xC2 Numpad XOR
//0xC3 Numpad ^
//0xC4 Numpad %
//0xC5 Numpad <
//0xC6 Numpad >
//0xC7 Numpad &
//0xC8 Numpad &&
//0xC9 Numpad |
//0xCA Numpad ||
//0xCB Numpad :
//0xCC Numpad #
//0xCD Numpad Space
//0xCE Numpad @
//0xCF Numpad !
//0xD0 Numpad Memory Store
//0xD1 Numpad Memory Recall
//0xD2 Numpad Memory Clear
//0xD3 Numpad Memory Add
//0xD4 Numpad Memory Subtract
//0xD5 Numpad Memory Multiply
//0xD6 Numpad Memory Divide
//0xD7 Numpad +/-
//0xD8 Numpad Clear
//0xD9 Numpad Clear Entry
//0xDA Numpad Binary
//0xDB Numpad Octal
//0xDC Numpad Decimal
//0xDD Numpad Hexadecimal

//0x95 LANG6
//0x96 LANG7
//0x97 LANG8
//0x98 LANG9
//0x99 Alternate Erase
//0x9A SysReq/Attention
//0x9B Cancel
//0x9C Clear
//0x9D Prior
//0x9E Return
//0x9F Separator
//0xA0 Out
//0xA1 Oper
//0xA2 Clear/Again
//0xA3 CrSel/Props
//0xA4 ExSel

//0xB0 Numpad 00
//0xB1 Numpad 000
//0xB2 Thousands Separator
//0xB3 Decimal Separator
//0xB4 Currency Unit
//0xB5 Currency Sub-unit
