#include "stdio.h"
#include "key_names.h"

/*

This code is for a homemade STM32-based USB keypad with multimedia buttons by Nanoslavic
My english YouTube https://www.youtube.com/@NanoslavicLab

Этот код для самодельной USB клавиатуры с медиа кнопками на основе STM32 от Нанославика
Мой русский канал YouTube https://www.youtube.com/@nanoslavic

*/

/*
This table describes the key combinations

The names of the buttons can be found in the file "key_names.h"

The combination consists of two bytes. The first byte is intended for setting modifiers. The second byte specifies one button.
Examples:

1) CTRL+V:
Modifiers = LEFT_CTRL
Key code = KEY_V

2) CTRL+SHIFT+V:
Modifiers = LEFT_CTRL|LEFT_SHIFT
Key code = KEY_V

3) Only "v" button:
Modifiers = KEY_NONE
Key code = KEY_V

4) Only "CTRL" button:
Modifiers = LEFT_CTRL
Key code = KEY_NONE

*/
const uint8_t KeyMap[KEY_NUMBER * 2] = {
	/*Modifiers for KEY1*/	LEFT_WIN|LEFT_SHIFT,
	/*Key code for KEY1*/	KEY_S,

	/*Modifiers for KEY2*/	KEY_NONE,
	/*Key code for KEY2*/	KEY_R,

	/*Modifiers for KEY3*/	LEFT_CTRL,
	/*Key code for KEY3*/	KEY_F10,

	/*Modifiers for KEY4*/	LEFT_ALT,
	/*Key code for KEY4*/	KEY_PRINTSCREEN,

	/*Modifiers for KEY5*/	KEY_NONE,
	/*Key code for KEY5*/	KEY_NONE,

	/*Modifiers for KEY6*/	KEY_NONE,
	/*Key code for KEY6*/	KEY_M,

	/*Modifiers for KEY7*/	LEFT_CTRL,
	/*Key code for KEY7*/	KEY_V,

	/*Modifiers for KEY8*/	KEY_NONE,
	/*Key code for KEY8*/	KEY_PRINTSCREEN,

	/*Modifiers for KEY9*/	KEY_NONE,
	/*Key code for KEY9*/	KEY_NONE,

	/*Modifiers for KEY10*/	LEFT_CTRL|LEFT_SHIFT,
	/*Key code for KEY10*/	KEY_Q,

	/*Modifiers for KEY11*/	LEFT_CTRL|LEFT_SHIFT,
	/*Key code for KEY11*/	KEY_V,

	/*Modifiers for KEY12*/	KEY_NONE,
	/*Key code for KEY12*/	KEY_LEFT,

	/*Modifiers for KEY13*/	KEY_NONE,
	/*Key code for KEY13*/	KEY_VOL_UP,

	/*Modifiers for KEY14*/	KEY_NONE,
	/*Key code for KEY14*/	KEY_VOL_DOWN,

	/*Modifiers for KEY15*/	LEFT_CTRL,
	/*Key code for KEY15*/	KEY_C,

	/*Modifiers for KEY16*/	KEY_NONE,
	/*Key code for KEY16*/	KEY_END,

	/*Modifiers for KEY17*/	KEY_NONE,
	/*Key code for KEY17*/	KEY_NONE,

	/*Modifiers for KEY18*/	KEY_NONE,
	/*Key code for KEY18*/	KEY_NONE,

	/*Modifiers for KEY19*/	KEY_NONE,
	/*Key code for KEY19*/	KEY_NONE,

	/*Modifiers for KEY20*/	KEY_NONE,
	/*Key code for KEY20*/	KEY_NONE,

	/*Modifiers for KEY21*/	KEY_NONE,
	/*Key code for KEY21*/	KEY_NONE,

	/*Modifiers for KEY22*/	KEY_NONE,
	/*Key code for KEY22*/	KEY_NONE,

	/*Modifiers for KEY23*/	KEY_NONE,
	/*Key code for KEY23*/	KEY_NONE,

	/*Modifiers for KEY24*/	KEY_NONE,
	/*Key code for KEY24*/	KEY_NONE,

	/*Modifiers for KEY25*/	KEY_NONE,
	/*Key code for KEY25*/	KEY_NONE,

	/*Modifiers for KEY26*/	KEY_NONE,
	/*Key code for KEY26*/	KEY_NONE,

	/*Modifiers for KEY27*/	KEY_NONE,
	/*Key code for KEY27*/	KEY_NONE,

	/*Modifiers for KEY28*/	KEY_NONE,
	/*Key code for KEY28*/	KEY_NONE,

	/*Modifiers for KEY29*/	KEY_NONE,
	/*Key code for KEY29*/	KEY_NONE,
	};
